// QFormSearchNode.cpp: implementation of the QFormSearchNode class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Query32.h"
#include "QFormSearchNode.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

QFormSearchNode::QFormSearchNode
    ( QDSManager *ds_arg,
			long conn_id_arg,
			QForm *form_arg,
      QFormInput *ffi_target_arg,
			PtrList<QFormInput> &ffi_left_list_arg,
      QDN &base_dn_arg,
			CString &filter_str_arg )
{
	WIN32_GUFF();

  //
  // Create the form search operation object
  op = new QFormOp( ds_arg, form_arg, conn_id_arg, base_dn_arg, filter_str_arg );

  //
  // Save remaining input fields
  ffi_target = ffi_target_arg;
  POSITION pos = ffi_left_list_arg.GetHeadPosition();
  while ( pos != NULL )
    {
      ffi_left_list.AddTail( ffi_left_list_arg.GetNext( pos ) );
    }
}

QFormSearchNode::~QFormSearchNode()
{
  delete op;
}

//////////////////////////////////////////////////////////////////////
// Return the form search input not used so far.
BOOL QFormSearchNode::GetRemainingInput
  ( QFormInput **target_ffi_ptr, PtrList<QFormInput> *left_ffi_ptr )
{
	WIN32_GUFF();

  *target_ffi_ptr = ffi_target;
  POSITION pos = ffi_left_list.GetHeadPosition();
  while ( pos != NULL )
    {
      left_ffi_ptr->AddTail( ffi_left_list.GetNext( pos ) );
    }

  return TRUE;
}

