// QAttr.h: interface for the QAttr class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QATTR_H__14DA5661_AFF4_11D2_89E9_C7DD96AE151A__INCLUDED_)
#define AFX_QATTR_H__14DA5661_AFF4_11D2_89E9_C7DD96AE151A__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Oidtable.h"
#include "ptrlist.h"
#include "qutil.h"

//
// Base class used to define classes for attributes of a given syntax
class AFX_EXT_CLASS QValue  
{
public:
	QValue( QSyntax *syntax, char *ldap_val_ptr, unsigned long len ) ;
	virtual ~QValue();

public:
  void Print( CString &str );
	void PrintRaw( CString &str );

  BOOL operator==( QValue &v );

public:
  unsigned long Length() { return len ; } ;
  char *Value() { return ldap_val_ptr ; } ;
  QSyntax *Syntax() { return syntax ; } ;

private:
  char *ldap_val_ptr;
  unsigned long len;
  QSyntax *syntax;
};

template AFX_EXT_CLASS PtrList<QValue>;

//
// Attribute storage class
class AFX_EXT_CLASS QAttr
{
public:
	QAttr( QAttrT *attrt );
	virtual ~QAttr();

public:
  QAttrT *Type() { return attrt ; } ;
  QSyntax *Syntax() { return syntax ; } ;

public:
  UINT CountValues() { return value_list.GetCount() ; } ;
  void PrintValues( QStringList &str_list );
  void GetValues( PtrList<QValue> &value_list );
  void AddValue( char * ldap_val_ptr, unsigned long len );

public:
  QAttr *Copy();

private:
  QAttrT *attrt;
  PtrList<QValue> value_list;
  QSyntax *syntax;
};

template AFX_EXT_CLASS PtrList<QAttr>;

#endif // !defined(AFX_QATTR_H__14DA5661_AFF4_11D2_89E9_C7DD96AE151A__INCLUDED_)
